#!/bin/bash

set -u

filename="${1:-example.txt}"

exec 3<"$filename"

OLDIFS="$IFS"
IFS=","
read -u 3 -a crabs

IFS=$'\n'
crabs=($(sort -n <<<"${crabs[*]}"))

mid_point=$((${#crabs[@]} / 2))
mid_val=${crabs[$mid_point]}

fuel=0

for (( a=0; a<${#crabs[@]}; a++ )); do
    diff=$((mid_val-${crabs[$a]}))
    diff=${diff#-}
    ((fuel+=$diff))
done

echo "Fuel needed: $fuel"
